/*----- PROTECTED REGION ID(E621StateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        E621StateMachine.cpp
//
// description : State machine file for the E621 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <E621.h>

/*----- PROTECTED REGION END -----*/	//	E621::E621StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  UNKNOWN  |  
//  ALARM    |  
//  MOVING   |  


namespace E621_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : E621::is_Firmware_allowed()
 *	Description: Execution allowed for Firmware attribute
 */
//--------------------------------------------------------
bool E621::is_Firmware_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(E621::FirmwareStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	E621::FirmwareStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E621::is_SerialNumber_allowed()
 *	Description: Execution allowed for SerialNumber attribute
 */
//--------------------------------------------------------
bool E621::is_SerialNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(E621::SerialNumberStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	E621::SerialNumberStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E621::is_AverageTimes_allowed()
 *	Description: Execution allowed for AverageTimes attribute
 */
//--------------------------------------------------------
bool E621::is_AverageTimes_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(E621::AverageTimesStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	E621::AverageTimesStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(E621::AverageTimesStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	E621::AverageTimesStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E621::is_Position_allowed()
 *	Description: Execution allowed for Position attribute
 */
//--------------------------------------------------------
bool E621::is_Position_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(E621::PositionStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	E621::PositionStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(E621::PositionStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	E621::PositionStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(E621::E621StateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	E621::E621StateAllowed.AdditionalMethods

}	//	End of namespace
